static int need_endgen,canfail;static void S_syntaksikuvaus(void);
static void S_hex(void);
static void S_hex2(void);
static void S_serial(void);
static void S_puskuri(void);
static void S_tunnus(void);
static void S_kirjain(void);
static void S_pilkku(void);
static void S_numero(void);
static void S_kokonaisluku(void);
static void S_rakenne(void);
static void S_lista(void);
static void S_kompleksi(void);
static void S_komplementtia(void);
static void S_komplementtib(void);
static void S_objekti(void);
static void S_objektia(void);
static void S_objektib(void);
static void S_semantiikka(void);
static void S_syntaksi(void);
static void S_vmerkki(void);
static void S_suodin(void);
static void S_arvoalue(void);
static void S_aluea(void);
static void S_alueb(void);
static void S_aluec(void);
static void S_alued(void);
static void S_aluee(void);
static void S_merkki(void);
static void S_merkkijono(void);
static void S_merkkijono2(void);
static void S_mjlaina(void);
static void S_mjlaina3(void);
static void S_mjlaina2(void);
static void S_mjlainagen(void);
static void S_mjmerkki(void);
static void S_mjmerkki2(void);
static void S_yhdiste(void);
static void S_optio(void);
static void S_toisto(void);
static void S_kutsu(void);
static void S_virhe(void);
static void S_vjono(void);
static void S_ehto(void);
static void S_ejono(void);
static void S_tulos(void);
static void S_kommentti(void);
static void S_sjono(void);
static void S_tkorvaus(void);
static void S_tulostin(void);
static void S_tjono(void);

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include <unistd.h>
#include <errno.h>

#include <fcntl.h>
#include <sys/stat.h>  

typedef struct bufferi
{
    ssize_t alku;
    ssize_t size;
}buff;

#define debug1 printf("** Debug: "
#define debug2 );__debug();

static unsigned char *b;
static buff source;

static ssize_t swap_loppu, table_loppu;

static ssize_t SourcePtr, SourceEnd;
static ssize_t dest_alku, dest_ptr;
static ssize_t swap_ptr, table_ptr;

#define source_ptr SourcePtr

static const char *sourcename="in";
static const char *destname="out";

static int ok;
static int synerr;
static long Riveja;

/******************************************************/
static unsigned long Rivinro(int tulo)
{
    ssize_t ptr, vpos;
    unsigned rivi=1;
    for(ptr=vpos=source.alku; ptr!=SourcePtr; ptr++)
        if(b[ptr]=='\n')
        {
            rivi++;
            vpos = ptr + 1;
        };
    if(tulo)printf("At line %u: ", rivi);
    return vpos;
}
static void __debug(void)
{
    ssize_t vpos;
    puts("");
    vpos=Rivinro(1);
    while(vpos != SourceEnd && b[vpos]!=10)putchar(b[vpos++]);
    puts("");
}
/******************************************************/
static void CleanUp(int code)
{
    if(b)free(b);
    exit(code);
}
/******************************************************/
static void destout(void);
static void virhe(const char *string)
{
    ssize_t haku, c;

    printf("\33[1m\r%s\33[m\n", string);
    if(errno)printf("Error %d: %s\n", errno, sys_errlist[errno]);
    if(synerr)
    {
        ssize_t vpos=Rivinro(1);
        while(vpos != SourceEnd && b[vpos]!=10)
        {
            if(b[vpos]!=13)putchar(b[vpos]);
            vpos++;
        }
        puts("");
    }
    for(c=0, haku=table_ptr; haku < table_loppu; c++)
    {
        haku += (int)b[haku]+1;
        haku += (int)b[haku]+1;
    }

    if(table_ptr < table_loppu)
    {
      int i;
      printf("Taulukossa on %u elementti, viimeksi listty: \"", c);
      haku=table_ptr;
      for(i=0; i<(int)b[haku]; i++)putchar(b[haku+i+1]);
      printf("\" = \"");
      haku += (int)b[haku] + 1;
      for(i=0; i<(int)b[haku]; i++)putchar(b[haku+i+1]);
      printf("\"\n");
    }

    destout();

    CleanUp(errno?errno:1);
}
/******************************************************/
static void table_insert(buff string, buff value)
{
    if(string.size > 255 || value.size > 255)                   virhe("String too long 'table_insert'");
    if((table_ptr -= string.size + value.size + 2) < swap_loppu)virhe("Out of memory 'table_insert'");
    b[table_ptr] = (char) string.size;
    memcpy(&b[table_ptr + 1], &b[string.alku], (int)string.size);
    b[table_ptr + string.size + 1] = (char) value.size;
    memcpy(&b[table_ptr + string.size + 2], &b[value.alku], (int)value.size);
}
/******************************************************/
static void destout(void)
{
    int fh;
    ssize_t size;
  
    fh = open (destname, O_WRONLY|O_CREAT|O_TRUNC, S_IREAD|S_IWRITE);
    if(fh==-1) virhe("Ei saa auki! 'destout'");
    size = dest_ptr-dest_alku;
    
    if(write(fh, &b[dest_alku], size) != (ssize_t)size)
        virhe("kaikki ei mennyt levylle.");

    if(close(fh)) virhe("Crash! 'destout'");
}
/******************************************************/
static void sourcein(void)
{
    int fh;
    ssize_t size, result;
  
    fh = open (sourcename, O_RDONLY);
    if(fh==-1)
    {
        printf("'%s' ", sourcename);
        virhe("virhe");
    }
    size = lseek(fh,0,SEEK_END);
    lseek(fh,0,SEEK_SET);
    
    if(size > swap_ptr-dest_ptr)
    {
        printf("Sourcefile size is %d bytes and free memory %d bytes. ",
               size, swap_ptr-dest_ptr);
        virhe("Stop.");
    }
    SourceEnd = swap_ptr;
    source.alku = (swap_ptr -= (source.size = size));
    result = read(fh, &b[source.alku], size);
    if(result != size)virhe("Kaikkea ei saatu luettua.");
    if(close(fh)) virhe("Crash! 'sourcein'");
    SourcePtr = swap_ptr;
}
/******************************************************/
static void Add(buff muisti)
{
    ssize_t ptr, size;
    if(dest_ptr+muisti.size > swap_ptr) virhe("Out of memory 'Add'");
    if(muisti.size > 0xffff) virhe("Liian suurta 'Add'");

    ptr=muisti.alku;
    size=muisti.size;
    while(size)
    {
        if((b[dest_ptr++] = b[ptr++])=='\n')
            Riveja++;
        size--;
    }
}
/******************************************************/
static void Gen(const char *string)
{
    while(*string)
    {
        if(dest_ptr==swap_ptr)virhe("Out of memory 'Gen'");
        if((b[dest_ptr++]=(unsigned char)*(string++))=='\n')
            Riveja++;
    }
}
/******************************************************/
static void table_search(buff string)
{
    ssize_t haku = table_ptr;
    buff result;

    while(haku < table_loppu)
    {
        if((char) string.size == b[haku]
            && !memcmp(&b[haku + 1], &b[string.alku], (int)string.size))
        {
            haku = haku + (int)b[haku] + 1;
            result.size = (long) b[haku];
            result.alku = haku + 1;
            Add(result);
            ok = 1;
            return;
        }
        haku = haku + (int)b[haku] + 1;
        haku = haku + (int)b[haku] + 1;
    }
    ok = 0;
}
/******************************************************/
static unsigned char nextin(void)
{
    if(SourcePtr==SourceEnd)return ok=0;
    {
        register unsigned char tmp = b[SourcePtr++];
        if(tmp=='\n')Riveja++;
        return tmp;
    }
}
static unsigned char testraja(unsigned char r1, unsigned char r2)
{
    if(SourcePtr==SourceEnd)return ok=0;
    {
        register unsigned char tmp = b[SourcePtr++];
        if(tmp=='\n')Riveja++;
        return tmp>=r1 && tmp<=r2;
    }
}
static unsigned char TeStRaja(unsigned char r1, unsigned char r2)
{
    if(SourcePtr==SourceEnd)return ok=0;
    {
        register unsigned char tmp = b[SourcePtr++];
        if(tmp=='\n')Riveja++;else tmp=toupper(tmp);
        return tmp>=toupper(r1) && tmp<=toupper(r2);
    }
}
/******************************************************/
static int Test(const char *string)
{
    ssize_t ptr=SourcePtr;
    while(*string && (ok=((unsigned char)*string==b[ptr]))) ptr++, string++;
    return ok ? SourcePtr=ptr, 1 : 0;
}
/******************************************************/
static int TeSt(const char *string)
{
    ssize_t ptr=SourcePtr;
    while(*string && (ok=(toupper(*string)==toupper(b[ptr])))) ptr++, string++;
    return ok ? SourcePtr=ptr, 1 : 0;
}
/******************************************************/
static void lower(buff muisti)
{
    unsigned char *p = &b[muisti.alku];
    ssize_t i = muisti.size;
    while(i)
    {
        *p = (unsigned char)tolower(*p);
        p++;
        i--;
    }
}
/******************************************************/
static void upper(buff muisti)
{
    unsigned char *p = &b[muisti.alku];
    ssize_t i = muisti.size;
    while(i)
    {
        *p = (unsigned char)toupper(*p);
        p++;
        i--;
    }
}
/******************************************************/
static void load_file(buff nimi, buff *paikka)
{
    int fh;
    ssize_t result;
  
    char buffer[13];
  
    if(nimi.size > 12)
    {
        printf("'");
        fwrite(&b[nimi.alku], 1, nimi.size, stdout);
        printf("':");
        virhe("liian pitk tiedostonimi");
    }
    memcpy(buffer, &b[nimi.alku], nimi.size);
    buffer[nimi.size] = 0;
  
    fh = open (buffer, O_RDONLY);
    if(fh==-1)
    {
        printf("'");
        fwrite(&b[nimi.alku], 1,  nimi.size, stdout);
        printf("' ");
        virhe("virhe");
    }
    paikka->size = lseek(fh,0,SEEK_END);
    lseek(fh,0,SEEK_SET);
    
    if(paikka->size > swap_ptr-dest_ptr) virhe("Lhdetiedosto on liian iso.");;
    paikka->alku = (swap_ptr -= paikka->size);
    result = read(fh, &b[paikka->alku], paikka->size);
    if(result != paikka->size ) virhe("Lhdetiedosto on liian iso.");
    if(close(fh)) virhe("Lhdetiedostoa ei saatu suljettua; DOS-vika.");
}
/******************************************************/
static void vie(ssize_t paikasta, buff *muisti)
{
    ssize_t size = dest_ptr-paikasta;
    if(size>0xffff) virhe("Liian suurta 'vie'");
    if((swap_ptr -= size) < dest_ptr) virhe("Muisti loppuu 'vie'");
    memcpy (&b[swap_ptr], &b[paikasta], size);
    dest_ptr = paikasta;
    muisti->alku = swap_ptr;
    muisti->size = size;
}
/******************************************************/
/* inline koodissa kytettv konversiofunktio        */
/* generoi annetusta numerosta integerin              */
/******************************************************/
static int integer(buff muisti, int radix)
{
    char buffer[7];  
    if(muisti.size>6) muisti.size=6;
    memcpy(buffer, &b[muisti.alku], muisti.size);
    buffer[muisti.size]=0;
    return strtol(buffer, NULL, radix);
}
/******************************************************/
/* inline koodissa kytettv konversiofunktio        */
/* generoi annetusta integerist merkkijonon          */
/******************************************************/
static void intstr(int luku)
{
    char Buffer[12];
    sprintf(Buffer, "%d", luku);
    Gen(Buffer);
}
/******************************************************/
static void Text(buff What)
{
    while(What.size)
    {
        putchar(b[What.alku++]);
        What.size--;
    }
}
/******************************************************/
int main(int argc, const char *const *argv)
{
    if(--argc)
    {
    	sourcename=*++argv;
	    if(--argc)destname=*++argv;
	}

    swap_loppu = 300000;
    table_loppu = 320000;

    SourcePtr=SourceEnd=dest_alku=dest_ptr=0;
    Riveja=synerr=0;

    b = NULL;

    swap_ptr=swap_loppu;
    table_ptr=table_loppu;

    ok = 1;
	b = (unsigned char *)calloc(table_loppu, 1);
    if(!b)
    {
        printf("Muistia on liian vhn kntjn tarpeisiin.\n");
        CleanUp(-1);
    }
  
    sourcein();
  
    ok=synerr=1;
    S_syntaksikuvaus();
  
    Test("\x1A");
    ok=(SourcePtr==SourceEnd);
    if(!ok)virhe("Koodissa oli virhe, jota ei lydetty.");
    if(SourcePtr!=SourceEnd) virhe("Sorsaa ei saada lopetettua!");

    destout();
  
    CleanUp(0);
    return 0;
}
/******************************************************/
/* inline koodissa kytettv konversiofunktio        */
/* generoi annetusta heksakoodista merkin tulokseen   */
/******************************************************/
static void genchar(buff muisti)
{
    int tulos;
    sscanf((char *)&b[muisti.alku], "%2X", &tulos);
    if(tulos==26)
        Gen("\\x1A");
    else
    {
        b[dest_ptr++]=(unsigned char) tulos;
        if(dest_ptr>swap_ptr) virhe("Out of memory");
    }
}
/******************************************************/
static void DoVirhe(void)
{
    buff B;
    int c;
    B.alku=SourcePtr;
    for(c=0;c<20;c++)nextin();
    B.size=SourcePtr-B.alku;
    printf("At this point: \"");
    Text(B);
    printf("\"\n");
}
static int space(void)
{
  while (isspace(b[SourcePtr]) && SourcePtr!=SourceEnd) SourcePtr++;
  return 0;
}
static int tuotaint(ssize_t luku)
{
	char jono[20], *string = jono;
	
	sprintf(string, "%d", luku);

	while (*string && dest_ptr != swap_ptr) b[dest_ptr++]=*(string++);
	if (dest_ptr==swap_ptr) virhe("Out of memory 'tuotaint'");
	return 0;
}
/* Tests for EOF */
static void S_EOF(void)
{
  ok = (SourcePtr >= SourceEnd);
}
static int need_endgen,canfail;static void S_syntaksikuvaus(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;for(;;){{ssize_t I=SourcePtr,O=dest_ptr;S_tulos();if(!ok)goto j_3;j_3:;if(ok)goto j_2;ok=1,SourcePtr=I,dest_ptr=O;{ssize_t M=SourcePtr;S_tunnus();B[2].alku=M;B[2].size=SourcePtr-M;}if(!ok)goto j_4;space();{ssize_t I=SourcePtr,O=dest_ptr;if(b[SourcePtr]=='=')++SourcePtr;else ok=0;if(!ok)goto j_6;j_6:;if(ok)goto j_5;ok=1,SourcePtr=I,dest_ptr=O;DoVirhe();virhe("Expected: \042=\042");if(!ok)goto j_7;j_7:;if(ok)goto j_5;SourcePtr=I,dest_ptr=O;j_5:;}if(!ok)goto j_4;space();{ssize_t I=SourcePtr,O=dest_ptr;Gen("static void S_");Add(B[2]);Gen("(void){buff B[10];ssize_t OSwp=swap_ptr;");if(!ok)goto j_9;S_rakenne();if(!ok)goto j_9;space();{ssize_t I=SourcePtr,O=dest_ptr;if(b[SourcePtr]=='.')++SourcePtr;else ok=0;if(!ok)goto j_11;j_11:;if(ok)goto j_10;ok=1,SourcePtr=I,dest_ptr=O;DoVirhe();virhe("Expected: \042.\042 or \042;\042");if(!ok)goto j_12;j_12:;if(ok)goto j_10;SourcePtr=I,dest_ptr=O;j_10:;}if(!ok)goto j_9;space();Gen("swap_ptr=OSwp;}\x0A");if(!ok)goto j_9;j_9:;if(ok)goto j_8;ok=1,SourcePtr=I,dest_ptr=O;DoVirhe();virhe("Rakenne puuttuu!");if(!ok)goto j_13;j_13:;if(ok)goto j_8;SourcePtr=I,dest_ptr=O;j_8:;}if(!ok)goto j_4;j_4:;if(ok)goto j_2;SourcePtr=I,dest_ptr=O;j_2:;}if(!ok)break;}ok=1;if(!ok)goto j_1;j_1:;if(ok)goto j_0;SourcePtr=I,dest_ptr=O;j_0:;}swap_ptr=OSwp;}
static void S_hex(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;if(b[SourcePtr]<'0'||b[SourcePtr]>'9')ok=0;else nextin();if(!ok)goto j_15;j_15:;if(ok)goto j_14;ok=1,SourcePtr=I,dest_ptr=O;{char c=toupper(b[SourcePtr]);if(c<toupper('A')||c>toupper('F'))ok=0;else nextin();}if(!ok)goto j_16;j_16:;if(ok)goto j_14;SourcePtr=I,dest_ptr=O;j_14:;}swap_ptr=OSwp;}
static void S_hex2(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;{ssize_t I=SourcePtr,O=dest_ptr;S_hex();if(!ok)goto j_20;S_hex();if(!ok)goto j_20;j_20:;if(ok)goto j_19;ok=1,SourcePtr=I,dest_ptr=O;DoVirhe();virhe("Ei ole heksaluku!");if(!ok)goto j_21;j_21:;if(ok)goto j_19;SourcePtr=I,dest_ptr=O;j_19:;}if(!ok)goto j_18;j_18:;if(ok)goto j_17;SourcePtr=I,dest_ptr=O;j_17:;}swap_ptr=OSwp;}
static void S_serial(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;Gen("j_");if(!ok)goto j_23;{static ssize_t N=0; tuotaint(N++);}if(!ok)goto j_23;j_23:;if(ok)goto j_22;SourcePtr=I,dest_ptr=O;j_22:;}swap_ptr=OSwp;}
static void S_puskuri(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;{ssize_t M=SourcePtr;if(b[SourcePtr]<'0'||b[SourcePtr]>'9')ok=0;else nextin();B[0].alku=M;B[0].size=SourcePtr-M;}if(!ok)goto j_25;{char c[2];c[c[1]=0,0]=b[B[0].alku]=='0'?'9':b[B[0].alku]-1;Gen(c);}if(!ok)goto j_25;j_25:;if(ok)goto j_24;SourcePtr=I,dest_ptr=O;j_24:;}swap_ptr=OSwp;}
static void S_tunnus(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;S_kirjain();if(!ok)goto j_27;for(;;){{ssize_t I=SourcePtr,O=dest_ptr;S_kirjain();if(!ok)goto j_29;j_29:;if(ok)goto j_28;ok=1,SourcePtr=I,dest_ptr=O;S_numero();if(!ok)goto j_30;j_30:;if(ok)goto j_28;SourcePtr=I,dest_ptr=O;j_28:;}if(!ok)break;}ok=1;if(!ok)goto j_27;j_27:;if(ok)goto j_26;SourcePtr=I,dest_ptr=O;j_26:;}swap_ptr=OSwp;}
static void S_kirjain(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;{char c=toupper(b[SourcePtr]);if(c<toupper('A')||c>toupper('Z'))ok=0;else nextin();}if(!ok)goto j_32;j_32:;if(ok)goto j_31;SourcePtr=I,dest_ptr=O;j_31:;}swap_ptr=OSwp;}
static void S_pilkku(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;for(;;){{ssize_t I=SourcePtr,O=dest_ptr;S_kommentti();if(!ok)goto j_36;j_36:;if(ok)goto j_35;SourcePtr=I,dest_ptr=O;j_35:;}if(!ok)break;}ok=1;if(!ok)goto j_34;space();{ssize_t I=SourcePtr,O=dest_ptr;if(b[SourcePtr]==',')++SourcePtr;else ok=0;if(!ok)goto j_38;space();Gen("space();");if(!ok)goto j_38;j_38:;if(ok)goto j_37;ok=1,SourcePtr=I,dest_ptr=O;if(b[SourcePtr]==';')++SourcePtr;else ok=0;if(!ok)goto j_39;j_39:;if(ok)goto j_37;SourcePtr=I,dest_ptr=O;j_37:;}if(!ok)goto j_34;space();for(;;){{ssize_t I=SourcePtr,O=dest_ptr;S_kommentti();if(!ok)goto j_41;j_41:;if(ok)goto j_40;SourcePtr=I,dest_ptr=O;j_40:;}if(!ok)break;}ok=1;if(!ok)goto j_34;j_34:;if(ok)goto j_33;SourcePtr=I,dest_ptr=O;j_33:;}swap_ptr=OSwp;}
static void S_numero(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;if(b[SourcePtr]<'0'||b[SourcePtr]>'9')ok=0;else nextin();if(!ok)goto j_43;j_43:;if(ok)goto j_42;SourcePtr=I,dest_ptr=O;j_42:;}swap_ptr=OSwp;}
static void S_kokonaisluku(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;S_numero();if(!ok)goto j_45;for(;;){{ssize_t I=SourcePtr,O=dest_ptr;S_numero();if(!ok)goto j_47;j_47:;if(ok)goto j_46;SourcePtr=I,dest_ptr=O;j_46:;}if(!ok)break;}ok=1;if(!ok)goto j_45;j_45:;if(ok)goto j_44;SourcePtr=I,dest_ptr=O;j_44:;}swap_ptr=OSwp;}
static void S_rakenne(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;{ssize_t R=dest_ptr;S_serial();vie(R, &B[7]);}if(!ok)goto j_49;Gen("{ssize_t I=SourcePtr,O=dest_ptr;");if(!ok)goto j_49;S_lista();if(!ok)goto j_49;space();for(;;){{ssize_t I=SourcePtr,O=dest_ptr;if(b[SourcePtr]=='|')++SourcePtr;else ok=0;if(!ok)goto j_51;space();Gen("if(ok)goto ");Add(B[7]);Gen(";ok=1,SourcePtr=I,dest_ptr=O;");if(!ok)goto j_51;S_lista();if(!ok)goto j_51;space();j_51:;if(ok)goto j_50;SourcePtr=I,dest_ptr=O;j_50:;}if(!ok)break;}ok=1;if(!ok)goto j_49;Gen("if(ok)goto ");Add(B[7]);Gen(";SourcePtr=I,dest_ptr=O;");Add(B[7]);Gen(":;}");if(!ok)goto j_49;j_49:;if(ok)goto j_48;SourcePtr=I,dest_ptr=O;j_48:;}swap_ptr=OSwp;}
static void S_lista(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;{ssize_t R=dest_ptr;S_serial();vie(R, &B[7]);}if(!ok)goto j_53;{ssize_t I=SourcePtr,O=dest_ptr;S_pilkku();if(!ok)goto j_55;j_55:;if(ok)goto j_54;SourcePtr=I,dest_ptr=O;j_54:;}ok=1;space();S_kompleksi();if(!ok)goto j_53;space();for(;;){{ssize_t I=SourcePtr,O=dest_ptr;{ssize_t I=SourcePtr,O=dest_ptr;ok=(!canfail);if(!ok)goto j_59;j_59:;if(ok)goto j_58;ok=1,SourcePtr=I,dest_ptr=O;Gen("if(!ok)goto ");Add(B[7]);Gen(";");if(!ok)goto j_60;j_60:;if(ok)goto j_58;SourcePtr=I,dest_ptr=O;j_58:;}if(!ok)goto j_57;S_pilkku();if(!ok)goto j_57;space();S_kompleksi();if(!ok)goto j_57;space();j_57:;if(ok)goto j_56;SourcePtr=I,dest_ptr=O;j_56:;}if(!ok)break;}ok=1;if(!ok)goto j_53;{ssize_t I=SourcePtr,O=dest_ptr;ok=(!canfail);if(!ok)goto j_62;j_62:;if(ok)goto j_61;ok=1,SourcePtr=I,dest_ptr=O;Gen("if(!ok)goto ");Add(B[7]);Gen(";");if(!ok)goto j_63;j_63:;if(ok)goto j_61;SourcePtr=I,dest_ptr=O;j_61:;}if(!ok)goto j_53;{ssize_t I=SourcePtr,O=dest_ptr;S_pilkku();if(!ok)goto j_65;j_65:;if(ok)goto j_64;SourcePtr=I,dest_ptr=O;j_64:;}ok=1;space();Add(B[7]);Gen(":;");if(!ok)goto j_53;j_53:;if(ok)goto j_52;SourcePtr=I,dest_ptr=O;j_52:;}swap_ptr=OSwp;}
static void S_kompleksi(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;canfail=1;{ssize_t I=SourcePtr,O=dest_ptr;{ssize_t R=dest_ptr;S_puskuri();vie(R, &B[0]);}if(!ok)goto j_69;space();if(b[SourcePtr]=='>')++SourcePtr;else ok=0;if(!ok)goto j_69;space();Gen("{buff V=source;ssize_t P=SourcePtr;");if(!ok)goto j_69;Gen("source=B[");Add(B[0]);Gen("];SourcePtr=source.alku;SourceEnd=source.alku+source.size;");if(!ok)goto j_69;S_komplementtia();if(!ok)goto j_69;Gen("source=V;SourcePtr=P;SourceEnd=source.alku+source.size;}");if(!ok)goto j_69;j_69:;if(ok)goto j_68;ok=1,SourcePtr=I,dest_ptr=O;S_komplementtia();if(!ok)goto j_70;j_70:;if(ok)goto j_68;SourcePtr=I,dest_ptr=O;j_68:;}if(!ok)goto j_67;{ssize_t I=SourcePtr,O=dest_ptr;space();if(b[SourcePtr]=='_')++SourcePtr;else ok=0;if(!ok)goto j_72;canfail=0;j_72:;if(ok)goto j_71;SourcePtr=I,dest_ptr=O;j_71:;}ok=1;j_67:;if(ok)goto j_66;SourcePtr=I,dest_ptr=O;j_66:;}swap_ptr=OSwp;}
static void S_komplementtia(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;{ssize_t R=dest_ptr;S_komplementtib();vie(R, &B[1]);}if(!ok)goto j_74;space();{ssize_t I=SourcePtr,O=dest_ptr;if(b[SourcePtr]==':')++SourcePtr;else ok=0;if(!ok)goto j_76;space();{ssize_t R=dest_ptr;S_puskuri();vie(R, &B[0]);}if(!ok)goto j_76;Gen("{ssize_t M=SourcePtr;");Add(B[1]);Gen("B[");Add(B[0]);Gen("].alku=M;B[");Add(B[0]);Gen("].size=SourcePtr-M;}");if(!ok)goto j_76;j_76:;if(ok)goto j_75;ok=1,SourcePtr=I,dest_ptr=O;Add(B[1]);if(!ok)goto j_77;j_77:;if(ok)goto j_75;SourcePtr=I,dest_ptr=O;j_75:;}if(!ok)goto j_74;j_74:;if(ok)goto j_73;SourcePtr=I,dest_ptr=O;j_73:;}swap_ptr=OSwp;}
static void S_komplementtib(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;{ssize_t R=dest_ptr;S_objekti();vie(R, &B[1]);}if(!ok)goto j_79;space();{ssize_t I=SourcePtr,O=dest_ptr;if(b[SourcePtr]=='>')++SourcePtr;else ok=0;if(!ok)goto j_81;space();{ssize_t R=dest_ptr;S_puskuri();vie(R, &B[0]);}if(!ok)goto j_81;Gen("{ssize_t R=dest_ptr;");Add(B[1]);Gen("vie(R, &B[");Add(B[0]);Gen("]);}");if(!ok)goto j_81;j_81:;if(ok)goto j_80;ok=1,SourcePtr=I,dest_ptr=O;Add(B[1]);if(!ok)goto j_82;j_82:;if(ok)goto j_80;SourcePtr=I,dest_ptr=O;j_80:;}if(!ok)goto j_79;j_79:;if(ok)goto j_78;SourcePtr=I,dest_ptr=O;j_78:;}swap_ptr=OSwp;}
static void S_objekti(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;if(b[SourcePtr]=='^')++SourcePtr;else ok=0;if(!ok)goto j_84;space();S_objektia();if(!ok)goto j_84;Gen("ok=!ok;");if(!ok)goto j_84;j_84:;if(ok)goto j_83;ok=1,SourcePtr=I,dest_ptr=O;S_objektia();if(!ok)goto j_85;j_85:;if(ok)goto j_83;SourcePtr=I,dest_ptr=O;j_83:;}swap_ptr=OSwp;}
static void S_objektia(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;{ssize_t M=SourcePtr;S_kokonaisluku();B[0].alku=M;B[0].size=SourcePtr-M;}if(!ok)goto j_87;space();if(b[SourcePtr]=='*')++SourcePtr;else ok=0;if(!ok)goto j_87;space();Gen("{int C;for(C=");Add(B[0]);Gen(";ok&&C;C--){");if(!ok)goto j_87;S_objektib();if(!ok)goto j_87;Gen("}}");if(!ok)goto j_87;j_87:;if(ok)goto j_86;ok=1,SourcePtr=I,dest_ptr=O;S_objektib();if(!ok)goto j_88;j_88:;if(ok)goto j_86;SourcePtr=I,dest_ptr=O;j_86:;}swap_ptr=OSwp;}
static void S_objektib(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;S_tunnus();if(!ok)goto j_90;space();if(b[SourcePtr]=='=')++SourcePtr;else ok=0;if(!ok)goto j_90;DoVirhe();virhe("Object terminator is '.', not ';'");if(!ok)goto j_90;j_90:;if(ok)goto j_89;ok=1,SourcePtr=I,dest_ptr=O;S_semantiikka();if(!ok)goto j_91;j_91:;if(ok)goto j_89;ok=1,SourcePtr=I,dest_ptr=O;S_syntaksi();if(!ok)goto j_92;j_92:;if(ok)goto j_89;SourcePtr=I,dest_ptr=O;j_89:;}swap_ptr=OSwp;}
static void S_semantiikka(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;S_tulos();if(!ok)goto j_94;j_94:;if(ok)goto j_93;ok=1,SourcePtr=I,dest_ptr=O;S_tulostin();if(!ok)goto j_95;j_95:;if(ok)goto j_93;SourcePtr=I,dest_ptr=O;j_93:;}swap_ptr=OSwp;}
static void S_syntaksi(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;{ssize_t M=SourcePtr;{ssize_t I=SourcePtr,O=dest_ptr;S_yhdiste();if(!ok)goto j_99;j_99:;if(ok)goto j_98;ok=1,SourcePtr=I,dest_ptr=O;S_optio();if(!ok)goto j_100;j_100:;if(ok)goto j_98;ok=1,SourcePtr=I,dest_ptr=O;S_toisto();if(!ok)goto j_101;j_101:;if(ok)goto j_98;ok=1,SourcePtr=I,dest_ptr=O;S_ehto();if(!ok)goto j_102;j_102:;if(ok)goto j_98;ok=1,SourcePtr=I,dest_ptr=O;S_suodin();if(!ok)goto j_103;j_103:;if(ok)goto j_98;ok=1,SourcePtr=I,dest_ptr=O;S_kutsu();if(!ok)goto j_104;j_104:;if(ok)goto j_98;ok=1,SourcePtr=I,dest_ptr=O;S_virhe();if(!ok)goto j_105;j_105:;if(ok)goto j_98;SourcePtr=I,dest_ptr=O;j_98:;}B[0].alku=M;B[0].size=SourcePtr-M;}if(!ok)goto j_97;space();{ssize_t I=SourcePtr,O=dest_ptr;if(b[SourcePtr]=='!')++SourcePtr;else ok=0;if(!ok)goto j_107;Gen("if(!ok)virhe(\042Tss pitisi olla ");if(!ok)goto j_107;{buff V=source;ssize_t P=SourcePtr;source=B[0];SourcePtr=source.alku;SourceEnd=source.alku+source.size;for(;;){{ssize_t I=SourcePtr,O=dest_ptr;S_vmerkki();if(!ok)goto j_109;j_109:;if(ok)goto j_108;SourcePtr=I,dest_ptr=O;j_108:;}if(!ok)break;}ok=1;source=V;SourcePtr=P;SourceEnd=source.alku+source.size;}if(!ok)goto j_107;Gen("\042);");if(!ok)goto j_107;j_107:;if(ok)goto j_106;SourcePtr=I,dest_ptr=O;j_106:;}ok=1;j_97:;if(ok)goto j_96;SourcePtr=I,dest_ptr=O;j_96:;}swap_ptr=OSwp;}
static void S_vmerkki(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;if(b[SourcePtr]=='\\')++SourcePtr;else ok=0;if(!ok)goto j_111;Gen("\\\\");if(!ok)goto j_111;j_111:;if(ok)goto j_110;ok=1,SourcePtr=I,dest_ptr=O;Test("\042");if(!ok)goto j_112;Gen("\\042");if(!ok)goto j_112;j_112:;if(ok)goto j_110;ok=1,SourcePtr=I,dest_ptr=O;{ssize_t M=SourcePtr;nextin();B[0].alku=M;B[0].size=SourcePtr-M;}if(!ok)goto j_113;Add(B[0]);if(!ok)goto j_113;j_113:;if(ok)goto j_110;SourcePtr=I,dest_ptr=O;j_110:;}swap_ptr=OSwp;}
static void S_suodin(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;S_arvoalue();if(!ok)goto j_115;j_115:;if(ok)goto j_114;ok=1,SourcePtr=I,dest_ptr=O;S_merkkijono();if(!ok)goto j_116;j_116:;if(ok)goto j_114;ok=1,SourcePtr=I,dest_ptr=O;S_merkkijono2();if(!ok)goto j_117;j_117:;if(ok)goto j_114;SourcePtr=I,dest_ptr=O;j_114:;}swap_ptr=OSwp;}
static void S_arvoalue(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;S_aluea();if(!ok)goto j_119;j_119:;if(ok)goto j_118;ok=1,SourcePtr=I,dest_ptr=O;S_alueb();if(!ok)goto j_120;j_120:;if(ok)goto j_118;ok=1,SourcePtr=I,dest_ptr=O;S_aluec();if(!ok)goto j_121;j_121:;if(ok)goto j_118;ok=1,SourcePtr=I,dest_ptr=O;S_alued();if(!ok)goto j_122;j_122:;if(ok)goto j_118;ok=1,SourcePtr=I,dest_ptr=O;S_aluee();if(!ok)goto j_123;j_123:;if(ok)goto j_118;SourcePtr=I,dest_ptr=O;j_118:;}swap_ptr=OSwp;}
static void S_aluea(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;Test("\042");if(!ok)goto j_125;{ssize_t R=dest_ptr;S_merkki();vie(R, &B[0]);}if(!ok)goto j_125;Test("\042");if(!ok)goto j_125;space();Test("..");if(!ok)goto j_125;space();Test("\042");if(!ok)goto j_125;{ssize_t R=dest_ptr;S_merkki();vie(R, &B[1]);}if(!ok)goto j_125;Test("\042");if(!ok)goto j_125;space();Gen("if(b[SourcePtr]<'");Add(B[0]);Gen("'||b[SourcePtr]>'");Add(B[1]);Gen("')ok=0;else nextin();");if(!ok)goto j_125;j_125:;if(ok)goto j_124;SourcePtr=I,dest_ptr=O;j_124:;}swap_ptr=OSwp;}
static void S_alueb(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;Test("\042");if(!ok)goto j_127;{ssize_t R=dest_ptr;S_merkki();vie(R, &B[0]);}if(!ok)goto j_127;Test("\042");if(!ok)goto j_127;space();Test("..");if(!ok)goto j_127;space();Gen("if(b[SourcePtr]<'");Add(B[0]);Gen("')ok=0;else nextin();");if(!ok)goto j_127;j_127:;if(ok)goto j_126;SourcePtr=I,dest_ptr=O;j_126:;}swap_ptr=OSwp;}
static void S_aluec(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;Test("..");if(!ok)goto j_129;space();Test("\042");if(!ok)goto j_129;{ssize_t R=dest_ptr;S_merkki();vie(R, &B[1]);}if(!ok)goto j_129;Test("\042");if(!ok)goto j_129;space();Gen("if(b[SourcePtr]>'");Add(B[1]);Gen("')ok=0;else nextin();");if(!ok)goto j_129;j_129:;if(ok)goto j_128;SourcePtr=I,dest_ptr=O;j_128:;}swap_ptr=OSwp;}
static void S_alued(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;Test("..");if(!ok)goto j_131;space();Gen("nextin();");if(!ok)goto j_131;j_131:;if(ok)goto j_130;SourcePtr=I,dest_ptr=O;j_130:;}swap_ptr=OSwp;}
static void S_aluee(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;if(b[SourcePtr]=='\'')++SourcePtr;else ok=0;if(!ok)goto j_133;{ssize_t R=dest_ptr;S_merkki();vie(R, &B[0]);}if(!ok)goto j_133;if(b[SourcePtr]=='\'')++SourcePtr;else ok=0;if(!ok)goto j_133;space();Test("..");if(!ok)goto j_133;space();if(b[SourcePtr]=='\'')++SourcePtr;else ok=0;if(!ok)goto j_133;{ssize_t R=dest_ptr;S_merkki();vie(R, &B[1]);}if(!ok)goto j_133;if(b[SourcePtr]=='\'')++SourcePtr;else ok=0;if(!ok)goto j_133;space();Gen("{char c=toupper(b[SourcePtr]);if(c<toupper('");Add(B[0]);Gen("')||c>toupper('");Add(B[1]);Gen("'))ok=0;else nextin();}");if(!ok)goto j_133;j_133:;if(ok)goto j_132;SourcePtr=I,dest_ptr=O;j_132:;}swap_ptr=OSwp;}
static void S_merkki(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;if(b[SourcePtr]=='\'')++SourcePtr;else ok=0;if(!ok)goto j_135;Gen("\\'");if(!ok)goto j_135;j_135:;if(ok)goto j_134;ok=1,SourcePtr=I,dest_ptr=O;if(b[SourcePtr]=='\\')++SourcePtr;else ok=0;if(!ok)goto j_136;Gen("\\");if(!ok)goto j_136;j_136:;if(ok)goto j_134;ok=1,SourcePtr=I,dest_ptr=O;Test("@@");if(!ok)goto j_137;Gen("@");if(!ok)goto j_137;j_137:;if(ok)goto j_134;ok=1,SourcePtr=I,dest_ptr=O;if(b[SourcePtr]=='@')++SourcePtr;else ok=0;if(!ok)goto j_138;{ssize_t M=SourcePtr;S_hex2();B[0].alku=M;B[0].size=SourcePtr-M;}if(!ok)goto j_138;Gen("\\x");Add(B[0]);if(!ok)goto j_138;j_138:;if(ok)goto j_134;ok=1,SourcePtr=I,dest_ptr=O;{ssize_t M=SourcePtr;if(b[SourcePtr]<' ')ok=0;else nextin();B[0].alku=M;B[0].size=SourcePtr-M;}if(!ok)goto j_139;Add(B[0]);if(!ok)goto j_139;j_139:;if(ok)goto j_134;ok=1,SourcePtr=I,dest_ptr=O;DoVirhe();virhe("Laiton merkki vakiossa");if(!ok)goto j_140;j_140:;if(ok)goto j_134;SourcePtr=I,dest_ptr=O;j_134:;}swap_ptr=OSwp;}
static void S_merkkijono(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;Test("\042");if(!ok)goto j_142;{ssize_t I=SourcePtr,O=dest_ptr;Gen("if(b[SourcePtr]=='");if(!ok)goto j_144;{ssize_t I=SourcePtr,O=dest_ptr;S_mjlaina3();if(!ok)goto j_146;j_146:;if(ok)goto j_145;ok=1,SourcePtr=I,dest_ptr=O;{ssize_t M=SourcePtr;S_mjmerkki();B[0].alku=M;B[0].size=SourcePtr-M;}if(!ok)goto j_147;Add(B[0]);if(!ok)goto j_147;j_147:;if(ok)goto j_145;SourcePtr=I,dest_ptr=O;j_145:;}if(!ok)goto j_144;Gen("')++SourcePtr;else ok=0;");if(!ok)goto j_144;Test("\042");if(!ok)goto j_144;Test("\042");ok=!ok;if(!ok)goto j_144;j_144:;if(ok)goto j_143;ok=1,SourcePtr=I,dest_ptr=O;Gen("Test(\042");if(!ok)goto j_148;for(;;){{ssize_t I=SourcePtr,O=dest_ptr;S_mjlaina();if(!ok)goto j_150;j_150:;if(ok)goto j_149;ok=1,SourcePtr=I,dest_ptr=O;{ssize_t M=SourcePtr;S_mjmerkki();B[0].alku=M;B[0].size=SourcePtr-M;}if(!ok)goto j_151;Add(B[0]);if(!ok)goto j_151;j_151:;if(ok)goto j_149;SourcePtr=I,dest_ptr=O;j_149:;}if(!ok)break;}ok=1;if(!ok)goto j_148;Gen("\042);");if(!ok)goto j_148;Test("\042");if(!ok)goto j_148;j_148:;if(ok)goto j_143;ok=1,SourcePtr=I,dest_ptr=O;DoVirhe();virhe("Pttymtn vertailujono");if(!ok)goto j_152;j_152:;if(ok)goto j_143;SourcePtr=I,dest_ptr=O;j_143:;}if(!ok)goto j_142;j_142:;if(ok)goto j_141;SourcePtr=I,dest_ptr=O;j_141:;}swap_ptr=OSwp;}
static void S_merkkijono2(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;if(b[SourcePtr]=='\'')++SourcePtr;else ok=0;if(!ok)goto j_154;{ssize_t I=SourcePtr,O=dest_ptr;Gen("if(toupper(b[SourcePtr])==toupper('");if(!ok)goto j_156;{ssize_t I=SourcePtr,O=dest_ptr;S_mjlaina3();if(!ok)goto j_158;j_158:;if(ok)goto j_157;ok=1,SourcePtr=I,dest_ptr=O;{ssize_t M=SourcePtr;S_mjmerkki2();B[0].alku=M;B[0].size=SourcePtr-M;}if(!ok)goto j_159;Add(B[0]);if(!ok)goto j_159;j_159:;if(ok)goto j_157;SourcePtr=I,dest_ptr=O;j_157:;}if(!ok)goto j_156;Gen("'))++SourcePtr;else ok=0;");if(!ok)goto j_156;if(b[SourcePtr]=='\'')++SourcePtr;else ok=0;if(!ok)goto j_156;if(b[SourcePtr]=='\'')++SourcePtr;else ok=0;ok=!ok;if(!ok)goto j_156;j_156:;if(ok)goto j_155;ok=1,SourcePtr=I,dest_ptr=O;Gen("TeSt(\042");if(!ok)goto j_160;for(;;){{ssize_t I=SourcePtr,O=dest_ptr;S_mjlaina2();if(!ok)goto j_162;j_162:;if(ok)goto j_161;ok=1,SourcePtr=I,dest_ptr=O;{ssize_t M=SourcePtr;S_mjmerkki2();B[0].alku=M;B[0].size=SourcePtr-M;}if(!ok)goto j_163;Add(B[0]);if(!ok)goto j_163;j_163:;if(ok)goto j_161;SourcePtr=I,dest_ptr=O;j_161:;}if(!ok)break;}ok=1;if(!ok)goto j_160;Gen("\042);");if(!ok)goto j_160;if(b[SourcePtr]=='\'')++SourcePtr;else ok=0;if(!ok)goto j_160;j_160:;if(ok)goto j_155;ok=1,SourcePtr=I,dest_ptr=O;DoVirhe();virhe("Pttymtn vertailujono");if(!ok)goto j_164;j_164:;if(ok)goto j_155;SourcePtr=I,dest_ptr=O;j_155:;}if(!ok)goto j_154;j_154:;if(ok)goto j_153;SourcePtr=I,dest_ptr=O;j_153:;}swap_ptr=OSwp;}
static void S_mjlaina(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;Test("\042\042");if(!ok)goto j_166;Gen("\\042");if(!ok)goto j_166;j_166:;if(ok)goto j_165;ok=1,SourcePtr=I,dest_ptr=O;S_mjlainagen();if(!ok)goto j_167;j_167:;if(ok)goto j_165;SourcePtr=I,dest_ptr=O;j_165:;}swap_ptr=OSwp;}
static void S_mjlaina3(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;if(b[SourcePtr]=='\'')++SourcePtr;else ok=0;if(!ok)goto j_169;Gen("\\'");if(!ok)goto j_169;j_169:;if(ok)goto j_168;ok=1,SourcePtr=I,dest_ptr=O;S_mjlainagen();if(!ok)goto j_170;j_170:;if(ok)goto j_168;SourcePtr=I,dest_ptr=O;j_168:;}swap_ptr=OSwp;}
static void S_mjlaina2(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;Test("\042");if(!ok)goto j_172;Gen("\\\042");if(!ok)goto j_172;j_172:;if(ok)goto j_171;ok=1,SourcePtr=I,dest_ptr=O;Test("''");if(!ok)goto j_173;Gen("'");if(!ok)goto j_173;j_173:;if(ok)goto j_171;ok=1,SourcePtr=I,dest_ptr=O;S_mjlainagen();if(!ok)goto j_174;j_174:;if(ok)goto j_171;SourcePtr=I,dest_ptr=O;j_171:;}swap_ptr=OSwp;}
static void S_mjlainagen(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;if(b[SourcePtr]=='\\')++SourcePtr;else ok=0;if(!ok)goto j_176;Gen("\\\\");if(!ok)goto j_176;j_176:;if(ok)goto j_175;ok=1,SourcePtr=I,dest_ptr=O;Test("@@");if(!ok)goto j_177;Gen("@");if(!ok)goto j_177;j_177:;if(ok)goto j_175;ok=1,SourcePtr=I,dest_ptr=O;if(b[SourcePtr]=='@')++SourcePtr;else ok=0;if(!ok)goto j_178;{ssize_t M=SourcePtr;S_hex2();B[0].alku=M;B[0].size=SourcePtr-M;}if(!ok)goto j_178;space();Gen("\\x");Add(B[0]);if(!ok)goto j_178;j_178:;if(ok)goto j_175;SourcePtr=I,dest_ptr=O;j_175:;}swap_ptr=OSwp;}
static void S_mjmerkki(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;Test("\042");ok=!ok;if(!ok)goto j_180;{ssize_t I=SourcePtr,O=dest_ptr;if(b[SourcePtr]<' ')ok=0;else nextin();if(!ok)goto j_182;j_182:;if(ok)goto j_181;ok=1,SourcePtr=I,dest_ptr=O;DoVirhe();virhe("Laiton merkki vertailujonossa");if(!ok)goto j_183;j_183:;if(ok)goto j_181;SourcePtr=I,dest_ptr=O;j_181:;}if(!ok)goto j_180;j_180:;if(ok)goto j_179;SourcePtr=I,dest_ptr=O;j_179:;}swap_ptr=OSwp;}
static void S_mjmerkki2(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;if(b[SourcePtr]=='\'')++SourcePtr;else ok=0;ok=!ok;if(!ok)goto j_185;{ssize_t I=SourcePtr,O=dest_ptr;if(b[SourcePtr]<' ')ok=0;else nextin();if(!ok)goto j_187;j_187:;if(ok)goto j_186;ok=1,SourcePtr=I,dest_ptr=O;DoVirhe();virhe("Laiton merkki vertailujonossa");if(!ok)goto j_188;j_188:;if(ok)goto j_186;SourcePtr=I,dest_ptr=O;j_186:;}if(!ok)goto j_185;j_185:;if(ok)goto j_184;SourcePtr=I,dest_ptr=O;j_184:;}swap_ptr=OSwp;}
static void S_yhdiste(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;if(b[SourcePtr]=='(')++SourcePtr;else ok=0;if(!ok)goto j_190;space();S_rakenne();if(!ok)goto j_190;space();{ssize_t I=SourcePtr,O=dest_ptr;if(b[SourcePtr]==')')++SourcePtr;else ok=0;if(!ok)goto j_192;j_192:;if(ok)goto j_191;ok=1,SourcePtr=I,dest_ptr=O;DoVirhe();virhe("Expected: \042)\042 or \042;\042");if(!ok)goto j_193;j_193:;if(ok)goto j_191;SourcePtr=I,dest_ptr=O;j_191:;}if(!ok)goto j_190;j_190:;if(ok)goto j_189;SourcePtr=I,dest_ptr=O;j_189:;}swap_ptr=OSwp;}
static void S_optio(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;if(b[SourcePtr]=='[')++SourcePtr;else ok=0;if(!ok)goto j_195;space();S_rakenne();if(!ok)goto j_195;space();{ssize_t I=SourcePtr,O=dest_ptr;if(b[SourcePtr]==']')++SourcePtr;else ok=0;if(!ok)goto j_197;j_197:;if(ok)goto j_196;ok=1,SourcePtr=I,dest_ptr=O;DoVirhe();virhe("Expected: \042]\042 or \042;\042");if(!ok)goto j_198;j_198:;if(ok)goto j_196;SourcePtr=I,dest_ptr=O;j_196:;}if(!ok)goto j_195;canfail=0;Gen("ok=1;");if(!ok)goto j_195;j_195:;if(ok)goto j_194;SourcePtr=I,dest_ptr=O;j_194:;}swap_ptr=OSwp;}
static void S_toisto(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;if(b[SourcePtr]=='{')++SourcePtr;else ok=0;if(!ok)goto j_200;space();Gen("for(;;){");if(!ok)goto j_200;S_rakenne();if(!ok)goto j_200;space();{ssize_t I=SourcePtr,O=dest_ptr;if(b[SourcePtr]=='}')++SourcePtr;else ok=0;if(!ok)goto j_202;j_202:;if(ok)goto j_201;ok=1,SourcePtr=I,dest_ptr=O;DoVirhe();virhe("Expected: \042}\042");if(!ok)goto j_203;j_203:;if(ok)goto j_201;SourcePtr=I,dest_ptr=O;j_201:;}if(!ok)goto j_200;space();Gen("if(!ok)break;}ok=1;");if(!ok)goto j_200;j_200:;if(ok)goto j_199;SourcePtr=I,dest_ptr=O;j_199:;}swap_ptr=OSwp;}
static void S_kutsu(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;{ssize_t M=SourcePtr;S_tunnus();B[0].alku=M;B[0].size=SourcePtr-M;}if(!ok)goto j_205;space();Gen("S_");Add(B[0]);Gen("();");if(!ok)goto j_205;j_205:;if(ok)goto j_204;SourcePtr=I,dest_ptr=O;j_204:;}swap_ptr=OSwp;}
static void S_virhe(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;if(b[SourcePtr]=='!')++SourcePtr;else ok=0;if(!ok)goto j_207;Gen("DoVirhe();virhe(\042");if(!ok)goto j_207;S_vjono();if(!ok)goto j_207;if(b[SourcePtr]=='!')++SourcePtr;else ok=0;if(!ok)goto j_207;space();Gen("\042);");if(!ok)goto j_207;j_207:;if(ok)goto j_206;SourcePtr=I,dest_ptr=O;j_206:;}swap_ptr=OSwp;}
static void S_vjono(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;for(;;){{ssize_t I=SourcePtr,O=dest_ptr;if(b[SourcePtr]=='\\')++SourcePtr;else ok=0;if(!ok)goto j_211;Gen("\\\\");if(!ok)goto j_211;j_211:;if(ok)goto j_210;ok=1,SourcePtr=I,dest_ptr=O;Test("\042");if(!ok)goto j_212;Gen("\\042");if(!ok)goto j_212;j_212:;if(ok)goto j_210;ok=1,SourcePtr=I,dest_ptr=O;Test("!!");if(!ok)goto j_213;Gen("!");if(!ok)goto j_213;j_213:;if(ok)goto j_210;ok=1,SourcePtr=I,dest_ptr=O;if(b[SourcePtr]=='!')++SourcePtr;else ok=0;ok=!ok;if(!ok)goto j_214;{ssize_t I=SourcePtr,O=dest_ptr;{ssize_t M=SourcePtr;if(b[SourcePtr]<' ')ok=0;else nextin();B[0].alku=M;B[0].size=SourcePtr-M;}if(!ok)goto j_216;Add(B[0]);if(!ok)goto j_216;j_216:;if(ok)goto j_215;ok=1,SourcePtr=I,dest_ptr=O;DoVirhe();virhe("Laiton merkki virheilmoituksessa");if(!ok)goto j_217;j_217:;if(ok)goto j_215;SourcePtr=I,dest_ptr=O;j_215:;}if(!ok)goto j_214;j_214:;if(ok)goto j_210;SourcePtr=I,dest_ptr=O;j_210:;}if(!ok)break;}ok=1;if(!ok)goto j_209;j_209:;if(ok)goto j_208;SourcePtr=I,dest_ptr=O;j_208:;}swap_ptr=OSwp;}
static void S_ehto(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;if(b[SourcePtr]=='?')++SourcePtr;else ok=0;if(!ok)goto j_219;Gen("ok=(");if(!ok)goto j_219;S_ejono();if(!ok)goto j_219;if(b[SourcePtr]=='?')++SourcePtr;else ok=0;if(!ok)goto j_219;space();Gen(");");if(!ok)goto j_219;j_219:;if(ok)goto j_218;SourcePtr=I,dest_ptr=O;j_218:;}swap_ptr=OSwp;}
static void S_ejono(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;for(;;){{ssize_t I=SourcePtr,O=dest_ptr;S_tkorvaus();if(!ok)goto j_223;j_223:;if(ok)goto j_222;ok=1,SourcePtr=I,dest_ptr=O;if(b[SourcePtr]=='\\')++SourcePtr;else ok=0;if(!ok)goto j_224;Gen("\\\\");if(!ok)goto j_224;j_224:;if(ok)goto j_222;ok=1,SourcePtr=I,dest_ptr=O;Test("\042");if(!ok)goto j_225;Gen("\\042");if(!ok)goto j_225;j_225:;if(ok)goto j_222;ok=1,SourcePtr=I,dest_ptr=O;Test("??");if(!ok)goto j_226;Gen("?");if(!ok)goto j_226;j_226:;if(ok)goto j_222;ok=1,SourcePtr=I,dest_ptr=O;if(b[SourcePtr]=='?')++SourcePtr;else ok=0;ok=!ok;if(!ok)goto j_227;{ssize_t I=SourcePtr,O=dest_ptr;{ssize_t M=SourcePtr;if(b[SourcePtr]<' ')ok=0;else nextin();B[0].alku=M;B[0].size=SourcePtr-M;}if(!ok)goto j_229;Add(B[0]);if(!ok)goto j_229;j_229:;if(ok)goto j_228;ok=1,SourcePtr=I,dest_ptr=O;DoVirhe();virhe("Laiton merkki ehtolausekkeessa");if(!ok)goto j_230;j_230:;if(ok)goto j_228;SourcePtr=I,dest_ptr=O;j_228:;}if(!ok)goto j_227;j_227:;if(ok)goto j_222;SourcePtr=I,dest_ptr=O;j_222:;}if(!ok)break;}ok=1;if(!ok)goto j_221;j_221:;if(ok)goto j_220;SourcePtr=I,dest_ptr=O;j_220:;}swap_ptr=OSwp;}
static void S_tulos(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;if(b[SourcePtr]=='#')++SourcePtr;else ok=0;if(!ok)goto j_232;S_sjono();if(!ok)goto j_232;if(b[SourcePtr]=='#')++SourcePtr;else ok=0;if(!ok)goto j_232;space();j_232:;if(ok)goto j_231;SourcePtr=I,dest_ptr=O;j_231:;}swap_ptr=OSwp;}
static void S_kommentti(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;Test("/*");if(!ok)goto j_234;for(;;){{ssize_t I=SourcePtr,O=dest_ptr;Test("*/");ok=!ok;if(!ok)goto j_236;nextin();if(!ok)goto j_236;j_236:;if(ok)goto j_235;SourcePtr=I,dest_ptr=O;j_235:;}if(!ok)break;}ok=1;if(!ok)goto j_234;Test("*/");if(!ok)goto j_234;space();j_234:;if(ok)goto j_233;SourcePtr=I,dest_ptr=O;j_233:;}swap_ptr=OSwp;}
static void S_sjono(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;for(;;){{ssize_t I=SourcePtr,O=dest_ptr;S_tkorvaus();if(!ok)goto j_240;j_240:;if(ok)goto j_239;ok=1,SourcePtr=I,dest_ptr=O;Test("##");if(!ok)goto j_241;Gen("#");if(!ok)goto j_241;j_241:;if(ok)goto j_239;ok=1,SourcePtr=I,dest_ptr=O;if(b[SourcePtr]=='\x0D')++SourcePtr;else ok=0;if(!ok)goto j_242;j_242:;if(ok)goto j_239;ok=1,SourcePtr=I,dest_ptr=O;if(b[SourcePtr]=='#')++SourcePtr;else ok=0;ok=!ok;if(!ok)goto j_243;{ssize_t I=SourcePtr,O=dest_ptr;{ssize_t M=SourcePtr;{ssize_t I=SourcePtr,O=dest_ptr;if(b[SourcePtr]<' ')ok=0;else nextin();if(!ok)goto j_247;j_247:;if(ok)goto j_246;ok=1,SourcePtr=I,dest_ptr=O;if(b[SourcePtr]=='\x0A')++SourcePtr;else ok=0;if(!ok)goto j_248;j_248:;if(ok)goto j_246;SourcePtr=I,dest_ptr=O;j_246:;}B[0].alku=M;B[0].size=SourcePtr-M;}if(!ok)goto j_245;Add(B[0]);if(!ok)goto j_245;j_245:;if(ok)goto j_244;ok=1,SourcePtr=I,dest_ptr=O;DoVirhe();virhe("Laiton merkki lisyksess");if(!ok)goto j_249;j_249:;if(ok)goto j_244;SourcePtr=I,dest_ptr=O;j_244:;}if(!ok)goto j_243;j_243:;if(ok)goto j_239;SourcePtr=I,dest_ptr=O;j_239:;}if(!ok)break;}ok=1;if(!ok)goto j_238;j_238:;if(ok)goto j_237;SourcePtr=I,dest_ptr=O;j_237:;}swap_ptr=OSwp;}
static void S_tkorvaus(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;Test("@@");if(!ok)goto j_251;Gen("@");if(!ok)goto j_251;j_251:;if(ok)goto j_250;ok=1,SourcePtr=I,dest_ptr=O;if(b[SourcePtr]=='@')++SourcePtr;else ok=0;if(!ok)goto j_252;{ssize_t M=SourcePtr;S_hex2();B[0].alku=M;B[0].size=SourcePtr-M;}if(!ok)goto j_252;genchar(B[0]);if(!ok)goto j_252;j_252:;if(ok)goto j_250;ok=1,SourcePtr=I,dest_ptr=O;Test("%%");if(!ok)goto j_253;Gen("%");if(!ok)goto j_253;j_253:;if(ok)goto j_250;ok=1,SourcePtr=I,dest_ptr=O;if(b[SourcePtr]=='%')++SourcePtr;else ok=0;if(!ok)goto j_254;{ssize_t R=dest_ptr;S_puskuri();vie(R, &B[0]);}if(!ok)goto j_254;Gen("B[");Add(B[0]);Gen("]");if(!ok)goto j_254;j_254:;if(ok)goto j_250;SourcePtr=I,dest_ptr=O;j_250:;}swap_ptr=OSwp;}
static void S_tulostin(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;if(b[SourcePtr]=='&')++SourcePtr;else ok=0;if(!ok)goto j_256;for(;;){{ssize_t I=SourcePtr,O=dest_ptr;if(b[SourcePtr]=='%')++SourcePtr;else ok=0;if(!ok)goto j_258;{ssize_t R=dest_ptr;S_puskuri();vie(R, &B[0]);}if(!ok)goto j_258;Gen("Add(B[");Add(B[0]);Gen("]);");if(!ok)goto j_258;j_258:;if(ok)goto j_257;SourcePtr=I,dest_ptr=O;j_257:;}if(!ok)break;}ok=1;if(!ok)goto j_256;{ssize_t I=SourcePtr,O=dest_ptr;if(b[SourcePtr]=='&')++SourcePtr;else ok=0;if(!ok)goto j_260;if(b[SourcePtr]=='&')++SourcePtr;else ok=0;ok=!ok;if(!ok)goto j_260;j_260:;if(ok)goto j_259;ok=1,SourcePtr=I,dest_ptr=O;Gen("Gen(\042");if(!ok)goto j_261;need_endgen=1;S_tjono();if(!ok)goto j_261;if(b[SourcePtr]=='&')++SourcePtr;else ok=0;if(!ok)goto j_261;space();{ssize_t I=SourcePtr,O=dest_ptr;ok=(need_endgen);if(!ok)goto j_263;Gen("\042);");if(!ok)goto j_263;j_263:;if(ok)goto j_262;SourcePtr=I,dest_ptr=O;j_262:;}ok=1;j_261:;if(ok)goto j_259;SourcePtr=I,dest_ptr=O;j_259:;}j_256:;if(ok)goto j_255;SourcePtr=I,dest_ptr=O;j_255:;}swap_ptr=OSwp;}
static void S_tjono(void){buff B[10];ssize_t OSwp=swap_ptr;{ssize_t I=SourcePtr,O=dest_ptr;for(;;){{ssize_t I=SourcePtr,O=dest_ptr;S_korvaus();if(!ok)goto j_267;j_267:;if(ok)goto j_266;ok=1,SourcePtr=I,dest_ptr=O;if(b[SourcePtr]=='\\')++SourcePtr;else ok=0;if(!ok)goto j_268;Gen("\\\\");if(!ok)goto j_268;j_268:;if(ok)goto j_266;ok=1,SourcePtr=I,dest_ptr=O;Test("\042");if(!ok)goto j_269;Gen("\\042");if(!ok)goto j_269;j_269:;if(ok)goto j_266;ok=1,SourcePtr=I,dest_ptr=O;Test("&&");if(!ok)goto j_270;Gen("&");if(!ok)goto j_270;j_270:;if(ok)goto j_266;ok=1,SourcePtr=I,dest_ptr=O;if(b[SourcePtr]=='\x0D')++SourcePtr;else ok=0;if(!ok)goto j_271;j_271:;if(ok)goto j_266;ok=1,SourcePtr=I,dest_ptr=O;if(b[SourcePtr]=='\x0A')++SourcePtr;else ok=0;if(!ok)goto j_272;Gen("\\n");if(!ok)goto j_272;j_272:;if(ok)goto j_266;ok=1,SourcePtr=I,dest_ptr=O;if(b[SourcePtr]=='&')++SourcePtr;else ok=0;ok=!ok;if(!ok)goto j_273;{ssize_t I=SourcePtr,O=dest_ptr;